# Vault: Managing Access to Groups and Policies

In this tutorial, you'll learn how to configure [Key Concepts](/how-abbey-works/concepts.md#grant-kits) to automate access requests to an admin access either by:

1. Adding yourself to an "oncall" vault group via [vault\_identity\_group\_member\_entity\_ids](https://registry.terraform.io/providers/hashicorp/vault/latest/docs/resources/identity_group_member_entity_ids), or
2. Assigning the admin policy directly to yourself via [vault\_identity\_group\_member\_entity\_ids](https://registry.terraform.io/providers/hashicorp/vault/latest/docs/resources/identity_group_member_entity_ids).

This use case models Role-Based Access Control (RBAC) using core Vault components.

We will be using the [Vault Starter Kit](https://github.com/abbeylabs/abbey-starter-kit-vault) as a base and replace configuration stubs for our use case.

## Before you start

1. **Make sure you have:**
   * An [Abbey account](https://app.abbey.so/sign-up)
   * An [Abbey API Token](/admin/managing-api-tokens.md#creating-new-api-tokens)
   * An Vault account
2. **Make sure you setup:**
   1. An [Vault Starter Kit](https://github.com/abbeylabs/abbey-starter-kit-vault) by following [Get a Starter Kit](/build-a-grant-kit/get-a-starter-kit.md)
   2. A Connection to a repo by following [Connect a Repo](/build-a-grant-kit/connect-a-repo.md)

## Step 1: Set Up Vault

Make sure your Vault account is good and ready to go. This Starter Kit will be creating 3 vault resources listed in `vault.tf`:

1. `vault_policy.admin_policy`
2. `vault_identity_group.oncall`
3. `vault_identity_entity.user1`

so make sure these don't already exist on your account to avoid conflicts.

## Step 2: Configure Your Grant Kit

### Configure Output

Grant Kits rely on your GitHub account and repository name to output access changes, which we'll set through Terraform local variables. Update the `locals` block in `main.tf` with your `account_name` and `repo_name`

{% code title="main.tf" %}

```hcl
 locals {
  account_name = "" #CHANGEME
  repo_name = "" #CHANGEME
  ...
}
```

{% endcode %}

### Configure Reviewers

Workflow defines who should approve an access request.&#x20;

Let's update the `reviewers` block by adding yourself as the reviewer by switching `replace-me@example.com` with the email address you use to sign into Abbey.&#x20;

{% code title="main.tf" %}

```diff
 resource "abbey_grant_kit" "..." {
   ...
   workflow = {
     steps = [
       {
         reviewers = {
-          one_of = ["replace-me@example.com"] # CHANGEME
+          one_of = ["alice@example.com"]
```

{% endcode %}

## Step 3: Link Vault with Abbey

Now you'll need to link [Vault with Abbey](https://developers.abbey.io/#operation/createAppData).

{% code title="" %}

```diff
curl -X POST \
  -H "Authorization: Bearer $ABBEY_API_TOKEN" \
  -H 'Content-Type: application/json' \
  https://api.abbey.io/v1/users/<user_id>/apps \
  -d '{"type": "vault", "data": {"user_id": "<your Vault User ID>"}}'
```

{% endcode %}

## Step 4: Deploy Your Starter Kit

First, add your GitHub-related secrets to your repo:

* `VAULT_ADDR`
* `VAULT_TOKEN`
* `ABBEY_TOKEN`

You can find the `VAULT_ADDR` and `VAULT_TOKEN` by going to <https://portal.cloud.hashicorp.com> and clicking on your Vault cluster for its details. `ABBEY_TOKEN` is your API token.

To deploy your Starter Kit, follow instructions from [Deploy Your Grant Kit](/build-a-grant-kit/deploying-your-grant-kit.md).

## Step 5: Automate Access Management

:tada: Congratulations! Abbey is now managing permissions to your Resource for you. :tada:

You can now start requesting and approving access by following the [Request Access](/build-a-grant-kit/requesting-access.md) and [Approve or Deny Access Requests](/build-a-grant-kit/approving-or-denying-access-requests.md) guides.

{% hint style="success" %}
Abbey strives to help you automate and secure access management without being intrusive.

To that end, this Pull Request contains native Terraform HCL code using normal open source Terraform Provider libraries. It represents the permissions change. In this case, it's just a simple creation of a new Terraform Resource.
{% endhint %}

## Step 6: Check approved requests in Vault

Go to the vault UI and confirm that the user is either (1) assigned to the oncall group, or (2) assigned the admin policy, depending on the resource you requested on Abbey.

## Next Steps

To learn more about what you can configure, try one of the [Data Integration](https://github.com/abbeylabs/docs/blob/main/getting-started/tutorials/broken-reference/README.md) tutorials. You can also look at [Infrastructure Integrations](https://github.com/abbeylabs/docs/blob/main/getting-started/tutorials/broken-reference/README.md) or get set up with a [TACOS](https://github.com/abbeylabs/docs/blob/main/getting-started/tutorials/broken-reference/README.md) of your choice.

For more information on how Abbey works, visit the [Key Concepts](/how-abbey-works/concepts.md) or [Grant Kits](/reference/grant-kits.md) page.


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.abbey.io/getting-started/tutorials/vault-managing-access-to-groups-and-policies.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
